package com.zplay.convertsdk;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.json.JSONException;
import org.json.JSONObject;
import org.xmlpull.v1.XmlPullParser;

import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.content.pm.ApplicationInfo;
import android.content.res.Resources;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.util.Log;
import android.util.Xml;
import android.view.LayoutInflater;
import android.view.View;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.ProgressBar;
import android.widget.Toast;

import com.e7studio.android.e7appsdk.utils.JSONBuilder;
import com.e7studio.android.e7appsdk.utils.JSONParser;
import com.e7studio.android.e7appsdk.utils.MapBuilder;
import com.e7studio.android.e7appsdk.utils.PhoneInfoHandler;
import com.e7studio.android.e7appsdk.utils.WebParamsMapBuilder;
import com.e7studio.android.e7appsdk.utils.WebTask;
import com.e7studio.android.e7appsdk.utils.WebTaskHandler;

public class ConvertSDK {
	public static String url;
	public static String gameID="";
	public static String channelID="";
	public static Boolean show=false;
	public static int TimeOut = 3 * 1000;
	public static final String ServerAddr = "http://popstar.zplay.cn/cdkey3/api_android_open.php";
	public static final String Encoding = "utf-8";
	public static String versionName="";
	public static ConvertCallBack convertcallcack;
	
	public static void initSDK(Activity activity,ConvertCallBack convertcallcack){
		ConvertSDK.convertcallcack=convertcallcack;
		 InputStream in;
//		 AnnouncentConfig.convertcallcack=initcallback;
			try {
				in = activity.getAssets().open("ZplayConfig.xml");
				convertpullxml(in);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			ConnectivityManager cManager=(ConnectivityManager)activity.getSystemService(Context.CONNECTIVITY_SERVICE);
			NetworkInfo info = cManager.getActiveNetworkInfo(); 
			  if (info == null ||(info != null&&!info.isAvailable())){ //不显示按钮
			       //do something 
				  convertcallcack.onCompleteInit("0");
			  }
			  else{
					if(!gameID.equals("")&&!channelID.equals("")){
						getConvertInit(activity);
					}
					else{
						convertcallcack.onCompleteInit("0");
					}
			  }
			
	}
	public static void getConvertInit(Activity activity) 
	{
		//http://popstar.zplay.cn/cdkey3/api_android_open.php?gameid=zplay001&channelid=zy001&ver=1.0
		String jsonResult = getServerBillingData(ServerAddr + "?" + "gameid="
				+ gameID + "&" + "channelid=" + channelID + "&" + "ver="+getAppVersionName(activity), Encoding);
		// {"success":"true","desc":"[{"cardNO":"1638005001005","password":"05232194","price":"5"}]"}
		// String
		// jsonResult="{\"success\":\"true\",\"desc\":[{\"cardNO\":\"1638005001005\",\"password\":\"05232194\",\"price\":\"5\"}]}";
//		Log.e("getConvertActivityResult",
//				"_____________________getConvertActivityResult" + jsonResult);

		if (jsonResult == null) {
			return;
		}
		else{
			convertcallcack.onCompleteInit(jsonResult);
		}

	}
	/**
	 * 获取网页Data
	 * 
	 * @param address
	 *            :地址
	 * @param encoding
	 *            :编码格式
	 * @return
	 */
	private static String getServerBillingData(String address, String encoding) {

		String line = "";
		StringBuffer sb = new StringBuffer();
		URL url;
		HttpURLConnection httpConnection = null;
		InputStream in = null;
		InputStreamReader isr = null;
		BufferedReader buff = null;
		try {
			url = new URL(address);
			httpConnection = (HttpURLConnection) url.openConnection();
			httpConnection.setConnectTimeout(TimeOut);
			int responseCode = httpConnection.getResponseCode();
			if (responseCode == HttpURLConnection.HTTP_OK) {
				in = httpConnection.getInputStream();
				isr = new InputStreamReader(in, encoding);
				buff = new BufferedReader(isr);
				while ((line = buff.readLine()) != null) {
					sb.append(line);
				}
				return sb.toString();
			} else {
				return null;
			}
		} catch (MalformedURLException e) {
			e.printStackTrace();
			Log.e("ConvertSDK", "getServerBillingData1:" + e.getMessage());
			convertcallcack.onCompleteInit("0");
			return null;
		} catch (IOException e) {
			e.printStackTrace();
			Log.e("ConvertSDK", "getServerBillingData2:" + e.getMessage());
			convertcallcack.onCompleteInit("0");
			return null;
		} catch (Exception e) {
			e.printStackTrace();
			Log.e("ConvertSDK", "getServerBillingData3:" + e.getMessage());
			convertcallcack.onCompleteInit("0");
			return null;
		} finally {
			if (httpConnection != null) {
				httpConnection.disconnect();
			}
			if (in != null) {
				try {
					in.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			if (isr != null) {
				try {
					isr.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			if (buff != null) {
				try {
					buff.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}

	}

	
	
	public static void getConvert(Activity activity,String cdkey,ConvertCallBack convertcallcack){
		 ConvertSDK.convertcallcack=convertcallcack;
		 if(!gameID.equals("")&&!channelID.equals("")){
					convert(activity,cdkey);
				}
				else{
					convertcallcack.onComplete("0");
				}
	}
	  private static void convert(final Activity activity,String cdkey) {
			long ts = System.currentTimeMillis();
			
			String device = PhoneInfoHandler.getIMEI(activity);
			String sign = ConvertEncrypter.doMD5EncodeWithLowercase(gameID + channelID
					+ device +cdkey+ "zplay888");
			new WebTaskHandler(activity, new WebTask() {
				public void doTask(final String arg0, final String arg1) {
					if (arg0 == null) {
						activity.runOnUiThread(new Runnable() {
							public void run() {
								Toast.makeText(activity, "请链接网络",
										Toast.LENGTH_SHORT).show();
								convertcallcack.onComplete(arg0);
							}
						});
					}else{
							convertcallcack.onComplete(arg0);
					} 
				}
			}, true, false, null, -1, false, false)
					.execute(WebParamsMapBuilder.buildParams(
							"http://popstar.zplay.cn/cdkey5/cdkey5/cdkey5in.php",
							JSONBuilder
									.buildJSON(
											MapBuilder.buildMap(
													new String[] { "data", "sign" },
													new Object[] {
															MapBuilder
																	.buildMap(
																			new String[] {
																					"gameID",
																					"channelID",
																					"device",
																					"devicetype",
																					"versionID",
																					"cdkey",
																					"ts" },
																			new String[] {
																					gameID,
																					channelID,
																					device,
																					"android",
																					getAppVersionName(activity),
																					cdkey,
																					String.valueOf(ts) }),
															sign })).toString()));
			
		}
		public static void convertpullxml(InputStream in) throws Exception {
			// 由android.util.Xml创建一个XmlPullParser实例
			XmlPullParser parser = Xml.newPullParser();
			// 设置输入流 并指明编码方式
			parser.setInput(in, "UTF-8");
			// 产生第一个事件
			int eventType = parser.getEventType();
			while (eventType != XmlPullParser.END_DOCUMENT) {
				switch (eventType) {
				// 判断当前事件是否为文档开始事件
				case XmlPullParser.START_DOCUMENT:
					// 初始化list集合
					break;
				// 判断当前事件是否为标签元素开始事件
				case XmlPullParser.START_TAG:
					if (parser.getName().equals("GameID")) {
						eventType = parser.next();
						if(!parser.getText().equals(null)){
						gameID=parser.getText();
						}
					}else if (parser.getName().equals("ChannelID")) {
						eventType = parser.next();
						// 得到book标签的属性值，并设置book的id
						if(!parser.getText().equals(null)){
							channelID=parser.getText();
						}
					} 
					break;
				// 判断当前事件是否为标签元素结束事件
				case XmlPullParser.END_TAG:
					break;
				}
				// 进入下一个元素并触发相应事件
				eventType = parser.next();
			}
		}
		/** 
		  * 返回当前程序版本名 
		  */  
		 public static  String getAppVersionName(Activity activity) {  
		     try {  
		         // ---get the package info---  
		         android.content.pm.PackageManager pm = activity.getPackageManager();  
		         android.content.pm.PackageInfo pi = pm.getPackageInfo(activity.getPackageName(), 0);  
		         versionName = pi.versionName;  
		         //String versioncode = pi.versionCode;
		         if (versionName == null || versionName.length() <= 0) {  
		             return "";  
		         }  
		     } catch (Exception e) {  
		         Log.e("VersionInfo", "Exception", e);  
		    }  
		     return versionName;  
		 } 
		 public static abstract class ConvertCallBack {
			   public abstract void onCompleteInit(String  isshow);
			   public abstract void onComplete(String  index);
			}


}
